// objcontrol.h : Declaration of the Cobjcontrol

#ifndef __OBJCONTROL_H_
#define __OBJCONTROL_H_

#include "resource.h"       // main symbols
#include <mtx.h>
#include <asptlb.h>

/////////////////////////////////////////////////////////////////////////////
// Cobjcontrol
class ATL_NO_VTABLE Cobjcontrol : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<Cobjcontrol, &CLSID_objcontrol>,
	public IObjectControl,
	public IDispatchImpl<Iobjcontrol, &IID_Iobjcontrol, &LIBID_CPPMTSOBJCONTROLLib>
{
public:
	Cobjcontrol()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_OBJCONTROL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

DECLARE_NOT_AGGREGATABLE(Cobjcontrol)

BEGIN_COM_MAP(Cobjcontrol)
	COM_INTERFACE_ENTRY(Iobjcontrol)
	COM_INTERFACE_ENTRY(IObjectControl)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IObjectControl
public:
	STDMETHOD(Activate)();
	STDMETHOD_(BOOL, CanBePooled)();
	STDMETHOD_(void, Deactivate)();

	CComPtr<IObjectContext> m_spObjectContext;

// Iobjcontrol
public:
	STDMETHOD(test)();

private:
	CComPtr<IResponse> m_piResponse;          
	CComPtr<IRequest> m_piRequest;          
	CComPtr<IServer> m_piServer;          
	CComPtr<IApplicationObject> m_piApplication;          
	CComPtr<ISessionObject> m_piSession;          
};

#endif //__OBJCONTROL_H_
